//
// first_open_save.c
//

#include <stdlib.h>

#include "first.h"

int firstOpenSaveFile( BOOL bOpen,
					  LPCSTR  lpcstrFilter,
					  LPCSTR  lpcstrDir,
					  LPCSTR  lpcstrTitle,
					  LPSTR   lpstrFileName,
					  DWORD   nFileNameLength )
{
	
	LPCSTR szTitle;
	LPCSTR szDir;
	char szFilter[260];
	char szCustomFilter[260];
	char szFile[260];
	char szFileTitle[260];
	
	char chReplace;
	int i, iResponse;
	
	OPENFILENAME ofn;  // common dialog box structure
	
	BOOL bResp;
	
	int re = 0;
	
	//---------------------------------------------
	
	strncpy( szFilter, lpcstrFilter, _MAX_PATH );
	
	
	//
	// Add a terminating null character to the Filter string.
	//
	
	chReplace = szFilter[ strlen(szFilter) - 1 ];
	
	for( i = 0; szFilter[i] != '\0'; i++ )
	{
		if( szFilter[i] == chReplace )
		{
			szFilter[i] = '\0';
		}
	}
	
	if( ! szFile )
	{
		firstShowMessage("firstOpenSaveFile: Not Enough Memory" );
		iResponse = MessageBox( hwndFirstFenster,
			"Not Enough Memory : Program STOPS",
			"wndOpenSaveFile", MB_OK | MB_ICONERROR );
		re = NO_SPACE;
		goto FINIS;
	}
	
	if( ! szCustomFilter )
	{
		firstShowMessage("firstOpenSaveFile: Not Enough Memory" );
		iResponse = MessageBox( hwndFirstFenster,
			"Not Enough Memory : Program STOPS",
			"firstOpenSaveFile", MB_OK | MB_ICONERROR );
		re = NO_SPACE;
		goto FINIS;
	}
	else
	{
		for( i = 0; szFilter[i] != '\0'; i++ )
		{
			szCustomFilter[i] = szFilter[i]; 
		}
		szCustomFilter[i] = '\0';
		i++;
		
		for( ; szFilter[i] != '\0'; i++ )
		{
			szCustomFilter[i] = szFilter[i]; 
		}
		szCustomFilter[i] = '\0';
		i++;
		szCustomFilter[i] = '\0';
		
	}
	
	szFile[0] = '\0';
	szCustomFilter[0] = '\0';
	szCustomFilter[1] = '\0';
	
	szTitle = lpcstrTitle;
	szDir   = lpcstrDir;
	
	//
	// Set the members of the OPENFILENAME structure
	//
	
	ofn.lStructSize       = sizeof( OPENFILENAME );
	ofn.hwndOwner         = hwndFirstFenster;
	
	ofn.lpstrFilter       = szFilter;
	
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = (DWORD)0;
	
	ofn.nFilterIndex      = (DWORD)1;
	
	ofn.lpstrFile         = szFile; // The path and name
	//	ofn.lpstrFile         = NULL; // The path and name
	ofn.nMaxFile          = (DWORD)260;
	
	ofn.lpstrFileTitle    = szFileTitle; // only the Name of the File
	ofn.nMaxFileTitle     = 260;
	
	ofn.lpstrInitialDir   = szDir;
	ofn.lpstrTitle        = szTitle;
	
	ofn.Flags             = OFN_LONGNAMES;
	
	ofn.nFileOffset       = (WORD) 0;
	ofn.nFileExtension    = (WORD) 0;
	ofn.lpstrDefExt       = "obj";
	
	
	ofn.lCustData         = (LPARAM) NULL;
	ofn.lpfnHook          = NULL;
	ofn.lpTemplateName    = NULL;
	
	
	
	if( bOpen )
	{
		bResp = GetOpenFileName( &ofn );
	}
	else
	{
		bResp = GetSaveFileName( &ofn );
	}
	
	if( bResp  )
	{   
		firstShowMessage( "SUCC" );
		
		//			MessageBox( hwndFirstFenster,
		//				szCustomFilter,
		//				"OpenSaveFile: CustomFilter", MB_OK );
		
		if( strlen( szFile ) < nFileNameLength )
		{
			strncpy( lpstrFileName, szFile, nFileNameLength  );
		}
		else
		{
			firstError( 
				"Space in Parameter lpstrFileName to short!\nSTOP ???",
				"wndOpenSaveFile" );
		}
	}
	else
	{
		firstShowMessage(" SUCC " );
		strncpy( lpstrFileName, "0000000000000", nFileNameLength-1 );
		re = NO_FILE;
	}
	
FINIS:;
	  return re;
	  
}
