//
// tk_init_window.c
//
// 98 - 12 - 28
//
static char version[] =
"$Id: tk_init_window.c,v 1.1 1999/11/21 15:20:43 Fusz Exp $";

#include "oTk_exp.h"
#include "oTk_intern.h"

//
// register a window class
// create a window of that class
//
//

//
// Globals
//
// HWND     tkhwnd;  // handle of the graphic window [write] tk_intern.h
// HDC      tkhdc;   // Device context               [write]
// HGLRC    tkhrc;   // OGL Rendering context        [write]
//

GLenum tkInitWindow(char *title )
{
    WNDCLASS wndclass;
    HANDLE   hInstance;
    ATOM     aRegister;
    RECT     WinRect;
	
    GLenum re = GL_TRUE;

    //------------------------------------------------------------------------
	
    hInstance = GetModuleHandle(NULL);
	
    //
    // register a window class
    //
	
    // Must not define CS_PARENTDC style.
    wndclass.style         = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc   = tkWndProc; 
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground = GetStockObject(BLACK_BRUSH);
    wndclass.lpszMenuName  = NULL;
	
    wndclass.lpszClassName = (LPCSTR)lpszClassName;
	
    aRegister = RegisterClass(&wndclass);
	
    /*
     *  If the window failed to register, then there's no
     *  need to continue further.
     */
	
    if(0 == aRegister)
    {
        fprintf( stderr, "Failed to register window class\n");
        re = GL_FALSE;
        return re;
    }
	
    /*
     *  Make window large enough to hold a client area as large as windInfo
     */

    WinRect.left   = windInfo.x;
    WinRect.right  = windInfo.x + windInfo.width;
    WinRect.top    = windInfo.y;
    WinRect.bottom = windInfo.y + windInfo.height;

    AdjustWindowRect(&WinRect, WS_OVERLAPPEDWINDOW, FALSE);

    tkhwnd = CreateWindow(
                          lpszClassName,
                          "TK_Window",
                          WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
                          (windInfo.bDefPos) ? CW_USEDEFAULT : WinRect.left,
                          (windInfo.bDefPos) ? CW_USEDEFAULT : WinRect.top,
                          WinRect.right - WinRect.left,
                          WinRect.bottom - WinRect.top,
                          NULL,
                          NULL,
                          hInstance,
                          NULL);
	
    tkhdc = GetDC(tkhwnd);
    if ( NULL == tkhdc )
    {
        fprintf( stderr, "TkInitWindow() : No Device Context\n" );
        re = GL_FALSE;
        goto FINIS;
    }
	
	
    ShowWindow(tkhwnd, SW_SHOWDEFAULT);
	
	
    if ( TkSetPixelFormat( tkhdc )  == FALSE )
    {
        fprintf( stderr, "TkInitWindow() : Error in TkSetPixelFormat()\n" );
        re = GL_FALSE;
        goto FINIS;
    }
	
    /*
     *  Create a Rendering Context
     */
    tkhrc = wglCreateContext(tkhdc);
    if ( NULL == tkhrc )
    {
        fprintf( stderr, "TkInitWindow() : No Rendering Context\n" );
        re = GL_FALSE;
        goto FINIS;
    }
	
    /*
     *  Make it Current
     */
    if ( wglMakeCurrent(tkhdc, tkhrc) == FALSE )
    {
        fprintf( stderr, "TkInitWindow() : wglMakeCurrent() failed\n" );
        re = GL_FALSE;
        goto FINIS;
    }
	
	
 FINIS:;
	  
    return re ;
}

